SystemOrganization addCategory: #'HTML5-Canvas-Tags'!
SystemOrganization addCategory: #'HTML5-Tests-Functional'!

!WAHtmlRoot methodsFor: '*HTML5' stamp: 'pmm 3/16/2007 12:09'!
beXhtml5
	docType := self xhtml5! !

!WAHtmlRoot methodsFor: '*HTML5' stamp: 'pmm 3/16/2007 12:09'!
xhtml5
	^'<!!DOCTYPE html>'! !

WAComponent subclass: #WACanvasTagTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML5-Tests-Functional'!

!WACanvasTagTest class methodsFor: 'testing' stamp: 'pmm 3/16/2007 15:13'!
canBeRoot
	^true! !

!WACanvasTagTest class methodsFor: 'class initialization' stamp: 'pmm 3/16/2007 15:13'!
initialize
	self registerAsApplication: 'tests/canvas'! !

!WACanvasTagTest methodsFor: 'private' stamp: 'pmm 3/16/2007 14:00'!
drawFunction
	"http://developer.mozilla.org/samples/canvas-tutorial/2_7_canvas_combined.html"
	^
'function drawShape(){
  // get the canvas element using the DOM
  var canvas = document.getElementById(''tutorial'');

  // Make sure we don''t execute when canvas isn''t supported
  if (canvas.getContext){

    // use getContext to use the canvas for drawing
    var ctx = canvas.getContext(''2d'');

    // Draw shapes
    roundedRect(ctx,12,12,150,150,15);
    roundedRect(ctx,19,19,150,150,9);
    roundedRect(ctx,53,53,49,33,10);
    roundedRect(ctx,53,119,49,16,6);
    roundedRect(ctx,135,53,49,33,10);
    roundedRect(ctx,135,119,25,49,10);

    // Character 1
    ctx.beginPath();
    ctx.arc(37,37,13,Math.PI/7,-Math.PI/7,false);
    ctx.lineTo(34,37);
    ctx.fill();

    // blocks
    for(i=0;i<8;i++){
      ctx.fillRect(51+i*16,35,4,4);
    }
    for(i=0;i<6;i++){
      ctx.fillRect(115,51+i*16,4,4);
    }
    for(i=0;i<8;i++){
      ctx.fillRect(51+i*16,99,4,4);
    }

    // character 2
    ctx.beginPath();
    ctx.moveTo(83,116);
    ctx.lineTo(83,102);
    ctx.bezierCurveTo(83,94,89,88,97,88);
    ctx.bezierCurveTo(105,88,111,94,111,102);
    ctx.lineTo(111,116);
    ctx.lineTo(106.333,111.333);
    ctx.lineTo(101.666,116);
    ctx.lineTo(97,111.333);
    ctx.lineTo(92.333,116);
    ctx.lineTo(87.666,111.333);
    ctx.lineTo(83,116);
    ctx.fill();
    ctx.fillStyle = "white";
    ctx.beginPath();
    ctx.moveTo(91,96);
    ctx.bezierCurveTo(88,96,87,99,87,101);
    ctx.bezierCurveTo(87,103,88,106,91,106);
    ctx.bezierCurveTo(94,106,95,103,95,101);
    ctx.bezierCurveTo(95,99,94,96,91,96);
    ctx.moveTo(103,96);
    ctx.bezierCurveTo(100,96,99,99,99,101);
    ctx.bezierCurveTo(99,103,100,106,103,106);
    ctx.bezierCurveTo(106,106,107,103,107,101);
    ctx.bezierCurveTo(107,99,106,96,103,96);
    ctx.fill();
    ctx.fillStyle = "black";
    ctx.beginPath();
    ctx.arc(101,102,2,0,Math.PI*2,true);
    ctx.fill();
    ctx.beginPath();
    ctx.arc(89,102,2,0,Math.PI*2,true);
    ctx.fill();
  } else {
    alert(''You need Safari or Firefox 1.5+ to see this demo.'');
  }
}

function roundedRect(ctx,x,y,width,height,radius){
  ctx.beginPath();
  ctx.moveTo(x,y+radius);
  ctx.lineTo(x,y+height-radius);
  ctx.quadraticCurveTo(x,y+height,x+radius,y+height);
  ctx.lineTo(x+width-radius,y+height);
  ctx.quadraticCurveTo(x+width,y+height,x+width,y+height-radius);
  ctx.lineTo(x+width,y+radius);
  ctx.quadraticCurveTo(x+width,y,x+width-radius,y);
  ctx.lineTo(x+radius,y);
  ctx.quadraticCurveTo(x,y,x,y+radius);
  ctx.stroke();
}
'! !

!WACanvasTagTest methodsFor: 'rendering' stamp: 'pmm 3/16/2007 14:03'!
renderContentOn: html
	html script: self drawFunction.
	html canvas id: 'tutorial'; width: 150; height: 150.
	html script: 'drawShape()'
! !

WAComponent subclass: #WAHtml5ElementsTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML5-Tests-Functional'!

!WAHtml5ElementsTest class methodsFor: 'testing' stamp: 'pmm 3/16/2007 15:12'!
canBeRoot
	^true! !

!WAHtml5ElementsTest class methodsFor: 'class initialization' stamp: 'pmm 3/16/2007 15:12'!
initialize
	self registerAsApplication: 'tests/html5'! !

!WAHtml5ElementsTest methodsFor: 'rendering' stamp: 'pmm 3/16/2007 14:08'!
renderContentOn: html
	html form: [
		html table: [
			html tableRow: [
				html tableHeading: [ html label: 'required' ].
				html tableData: [ html textInput required ] ].
			html tableRow: [
				html tableHeading: [ html label: 'autofocus' ].
				html tableData: [ html textInput autofocus ] ].
			html tableRow: [
				html tableHeading: [ html label: 'search' ].
				html tableData: [ html searchInput
					autosave: 'Seaside';
					placeholder: 'placeholder ...';
					results: 5;
					incremental: false ] ].
			html tableRow: [
				html tableHeading: [ html label: 'range (6..12) by 2' ].
				html tableData: [ html rangeInput
					min: 6;
					max: 12;
					step: 2 ] ].
			html tableRow: [
				html tableHeading: [ html label: 'email' ].
				html tableData: [ html emailInput ] ].
			html tableRow: [
				html tableHeading: [ html label: 'url' ].
				html tableData: [ html urlInput] ].
			html tableRow: [
				html tableHeading: [ html label: 'number' ].
				html tableData: [ html numberInput ] ].
			html tableRow: [
				html tableHeading: [ html label: 'datetimelocal' ].
				html tableData: [ html dateTimeLocalInput ] ].
			html tableRow: [
				html tableHeading: [ html label: 'datetime' ].
				html tableData: [ html dateTimeInput ] ].
			html tableRow: [
				html tableHeading: [ html label: 'date' ].
				html tableData: [ html dateInput5 ] ].
			html tableRow: [
				html tableHeading: [ html label: 'time' ].
				html tableData: [ html timeInput5 ] ].
			html tableRow: [
				html tableHeading: [ html label: 'month' ].
				html tableData: [ html monthInput step: 3 ] ].
			html tableRow: [
				html tableHeading: [ html label: 'week' ].
				html tableData: [ html weekInput ] ] ].
		html submitButton ]! !

WATagBrush subclass: #WACanvasTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML5-Canvas-Tags'!

!WACanvasTag commentStamp: 'pmm 3/16/2007 11:52' prior: 0!
supported on:
- Firefox 1.5
- Safari 2
- Opera 9

http://www.whatwg.org/specs/web-apps/current-work/#the-canvas
http://developer.mozilla.org/en/docs/Canvas_tutorial!

!WACanvasTag methodsFor: 'attributes' stamp: 'lr 5/18/2006 08:52'!
extent: aPoint
	self width: aPoint x; height: aPoint y! !

!WACanvasTag methodsFor: 'attributes' stamp: 'lr 5/18/2006 08:51'!
height: aNumber
	self attributeAt: 'height' put: aNumber displayString! !

!WACanvasTag methodsFor: 'accessing' stamp: 'lr 5/18/2006 08:50'!
tag
	^ 'canvas'! !

!WACanvasTag methodsFor: 'attributes' stamp: 'lr 5/18/2006 08:51'!
width: aNumber
	self attributeAt: 'width' put: aNumber displayString! !

!WATagBrush methodsFor: '*HTML5' stamp: 'pmm 3/16/2007 12:05'!
autofocus
	"supported on:
	- Opera 9"
	self attributeAt: 'autofocus' put: true! !

!WATagBrush methodsFor: '*HTML5' stamp: 'pmm 3/16/2007 13:11'!
onInput: aString
	"Any element that accepts an onchange attribute to handle change events shall also accept an oninput  attribute to handle input events, except the output element (for which it would make no sense)."
	self attributes at: 'oninput' append: aString separator: ';'! !

!WATagBrush methodsFor: '*HTML5' stamp: 'pmm 3/16/2007 12:07'!
required
	"supported on:
	- Opera 9"
	self attributeAt: 'required' put: true! !

WATagBrush subclass: #WAVideoTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML5-Canvas-Tags'!

!WAVideoTag commentStamp: 'pmm 3/18/2007 12:58' prior: 0!
no known browser support, might require an open codec like Ogg Theora, might first appear in Opera and Mozilla

A video element represents a video or movie, with an alternate representation given by its contents.

http://www.whatwg.org/specs/web-apps/current-work/#video
http://lists.whatwg.org/pipermail/whatwg-whatwg.org/attachments/20070228/6a0cdddc/attachment.txt!

!WAVideoTag methodsFor: 'attributes' stamp: 'pmm 3/18/2007 12:57'!
height: anInteger
	"The videoHeight  DOM attribute must return the native height of the video in CSS pixels. In the absence of resolution information, user agents may assume that one pixel in the video corresponds to one CSS pixel."
	self attributeAt: 'height' put: anInteger! !

!WAVideoTag methodsFor: 'attributes' stamp: 'pmm 3/18/2007 12:54'!
url: aString
	self attributeAt: 'src' put: aString! !

!WAVideoTag methodsFor: 'attributes' stamp: 'pmm 3/18/2007 12:57'!
width: anInteger
	"The videoWidth DOM attribute must return the native width of the video in CSS pixels. In the absence of resolution information, user agents may assume that one pixel in the video corresponds to one CSS pixel."
	self attributeAt: 'width' put: anInteger! !

!WARenderCanvas methodsFor: '*HTML5' stamp: 'pmm 3/16/2007 13:53'!
dateInput5
	^ self brush: WADateTag new! !

!WARenderCanvas methodsFor: '*HTML5' stamp: 'pmm 3/16/2007 13:53'!
dateTimeInput
	^ self brush: WADateTimeTag new! !

!WARenderCanvas methodsFor: '*HTML5' stamp: 'pmm 3/16/2007 13:54'!
dateTimeLocalInput
	^ self brush: WADateTimeLocalTag new! !

!WARenderCanvas methodsFor: '*HTML5' stamp: 'pmm 3/16/2007 13:32'!
emailInput
	^ self brush: WAEmailTag new! !

!WARenderCanvas methodsFor: '*HTML5' stamp: 'pmm 3/16/2007 13:53'!
monthInput
	^ self brush: WAMonthTag new! !

!WARenderCanvas methodsFor: '*HTML5' stamp: 'pmm 3/16/2007 13:08'!
numberInput
	^ self brush: WANumberTag new! !

!WARenderCanvas methodsFor: '*HTML5' stamp: 'pmm 3/16/2007 13:07'!
rangeInput
	^ self brush: WARangeTag new! !

!WARenderCanvas methodsFor: '*HTML5' stamp: 'pmm 3/16/2007 13:07'!
searchInput
	^ self brush: WASearchTag new! !

!WARenderCanvas methodsFor: '*HTML5' stamp: 'pmm 3/16/2007 13:53'!
timeInput5
	^ self brush: WATimeTag new! !

!WARenderCanvas methodsFor: '*HTML5' stamp: 'pmm 3/16/2007 13:32'!
urlInput
	^ self brush: WAUrlTag new! !

!WARenderCanvas methodsFor: '*HTML5' stamp: 'pmm 3/16/2007 13:52'!
weekInput
	^ self brush: WAWeekTag new! !

!WAHtmlCanvas methodsFor: '*HTML5' stamp: 'lr 5/18/2006 08:55'!
canvas
	^ self brush: WACanvasTag new! !

!WAHtmlCanvas methodsFor: '*HTML5' stamp: 'mb 11/30/2006 16:29'!
canvas: aBlock
	self canvas with: aBlock! !

!WAHtmlCanvas methodsFor: '*HTML5' stamp: 'pmm 3/18/2007 13:26'!
figure
	"no known browser support
	
	The figure element represents a paragraph consisting of embedded content and a caption.

The first embedded content element child of the figure element, if any, is the paragraph's content.

The first legend element child of the element, if any, represents the caption of the embedded content. If there is no child legend element, then there is no caption. 

	e.g.:
	html figure: [
		html legend: 'Credit: Media Inc., 2007'.
		html image url: 'smith.jpg'; altText: 'Photo: J. Smith' ]"
	^ self tag: 'figure'! !

!WAHtmlCanvas methodsFor: '*HTML5' stamp: 'pmm 3/18/2007 13:25'!
figure: aBlock
	self figure with: aBlock! !

!WAHtmlCanvas methodsFor: '*HTML5' stamp: 'pmm 3/18/2007 13:29'!
marked
	"no known browser support
	
	The m element represents a run of text marked or highlighted.

In the following snippet, a paragraph of text refers to a specific part of a code fragment.

<p>The highlighted part below is where the error lies:</p>
<pre><code>var i: Integer;
begin
   i := <m>1.1</m>;
end.</code></pre>

Another example of the m element is highlighting parts of a document that are matching some search string. If someone looked at a document, and the server knew that the user was searching for the word 'kitten', then the server might return the document with one paragraph modified as follows:

<p>I also have some <m>kitten</m>s who are visiting me
these days. They're really cute. I think they like my garden!!</p>"
	^ self tag: 'm'! !

!WAHtmlCanvas methodsFor: '*HTML5' stamp: 'pmm 3/18/2007 13:29'!
marked: aBlock
	self marked with: aBlock! !

!WAHtmlCanvas methodsFor: '*HTML5' stamp: 'pmm 3/18/2007 12:58'!
video
	^ self brush: WAVideoTag new! !

!WAHtmlCanvas methodsFor: '*HTML5' stamp: 'pmm 3/18/2007 12:58'!
video: aBlock
	self video with: aBlock! !

WAAbstractTextAreaTag subclass: #WAEmailTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML5-Canvas-Tags'!

!WAEmailTag commentStamp: 'pmm 3/16/2007 13:38' prior: 0!
supported on:
- Opera 9
graceful degeneration to text input

An e-mail address, following the format of the addr-spec  token defined in RFC 2822 section 3.4.1 [RFC2822], but excluding the CFWS  subtoken everywhere, and excluding the FWS subtoken everywhere except in the quoted-string subtoken. UAs could, for example, offer e-mail addresses from the user's address book. (See below for notes on IDN.)!

!WAEmailTag methodsFor: 'accessing' stamp: 'pmm 3/16/2007 12:02'!
type
	^'email'! !

WAAbstractTextAreaTag subclass: #WASearchTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML5-Canvas-Tags'!

!WASearchTag commentStamp: 'pmm 3/16/2007 13:37' prior: 0!
supported on:
- Safari 1.3 and 2.0
not (yet) part of HTML5
graceful degeneration to text input

http://weblogs.mozillazine.org/hyatt/archives/2004_07.html#005890!

!WASearchTag methodsFor: 'attributes' stamp: 'pmm 3/16/2007 11:47'!
autosave: aString
	"The autosave attribute allows you to specify an autosave name for your search results in the dropdown. What's cool about the autosave is that it's global, which means that two Web sites could put up a search field with an autosave name of google and then they would share the search results. (Since the actual result values are not accessible to the page there is no privacy violation.)"
	self attributeAt: 'autosave' put: aString! !

!WASearchTag methodsFor: 'attributes' stamp: 'pmm 3/16/2007 11:46'!
incremental: aBoolean
	"The incremental attribute can be used to control whether or not the search is performed as you type."
	self attributeAt: 'incremental' put: aBoolean! !

!WASearchTag methodsFor: 'events' stamp: 'pmm 3/16/2007 11:44'!
onSearch: aString
	"The search DOM event fires at the precise time the search should be performed and obeys the heuristic for the control, so you don't have to trap key and click events at all. You can use the onsearch attribute on the control to respond when the search happens."

	self attributes at: 'onsearch' append: aString separator: ';'! !

!WASearchTag methodsFor: 'attributes' stamp: 'pmm 3/16/2007 11:46'!
placeholder: aString
	"The placeholder attribute can be used to set the greyed placeholder text in the control."
	self attributeAt: 'placeholder' put: aString! !

!WASearchTag methodsFor: 'attributes' stamp: 'pmm 3/16/2007 11:43'!
results: aNumber
	"The results attribute allows you to specify how many results should be displayed in the dropdown."
	self attributeAt: 'results' put: aNumber! !

!WASearchTag methodsFor: 'accessing' stamp: 'pmm 3/16/2007 11:39'!
type
	^'search'! !

WAAbstractTextAreaTag subclass: #WASteppedTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML5-Canvas-Tags'!

!WASteppedTag commentStamp: 'pmm 3/16/2007 13:02' prior: 0!
abstract class for all the elments that have a step attribute!

WASteppedTag subclass: #WAClosedRangeTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML5-Canvas-Tags'!

!WAClosedRangeTag commentStamp: 'pmm 3/16/2007 13:02' prior: 0!
abstract class for all the elments that have a step, min and max attribute!

!WAClosedRangeTag methodsFor: 'attributes' stamp: 'pmm 3/16/2007 13:02'!
max: anInteger
	self attributeAt: 'max' put: anInteger! !

!WAClosedRangeTag methodsFor: 'attributes' stamp: 'pmm 3/16/2007 13:02'!
min: anInteger
	self attributeAt: 'min' put: anInteger! !

WAClosedRangeTag subclass: #WARangeTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML5-Canvas-Tags'!

!WARangeTag commentStamp: 'pmm 3/16/2007 13:38' prior: 0!
supported on:
- Safari 2.0 (slider)
graceful degeneration to text input

For this type, step defaults to 1, min defaults to 0, max defaults to 100, and value  defaults to the min value.

Volume controls and brightness controls would be good examples of "range" data controls.!

!WARangeTag methodsFor: 'accessing' stamp: 'pmm 3/16/2007 11:58'!
type
	^'range'! !

WAClosedRangeTag subclass: #WATimeTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML5-Canvas-Tags'!

!WATimeTag commentStamp: 'pmm 3/16/2007 14:05' prior: 0!
supported on:
- Opera 9
graceful degeneration to text input

A time (hour, minute, seconds, fractional seconds) encoded according to ISO 8601 [ISO8601] with no time zone: two digits (0-9) for the hour, a colon (U+003A), two digits for the minute, optionally a colon and two digits for the second, and optionally (if the seconds are present) a period (U+002E) and one or more digits for the fraction of a second. All the numbers must be in base ten and zero-padded if necessary. If the seconds are omitted, they must be assumed to be zero. If the fraction is omitted, it must be assumed to be zero as well. For instance: 23:59:00.00000 or 00:00:05. The step attribute specifies the precision in seconds, defaulting to 60. Times must be greater than or equal to 0 and must be less than 24 hours, in addition to any tighter restrictions placed on the control by the min and max attributes. Note that this type is not an elapsed time data type.

User agents are expected to show an appropriate widget, such as a clock. UAs should make it clear to the user that the time does not carry any time zone information. !

!WATimeTag methodsFor: 'accessing' stamp: 'pmm 3/16/2007 13:47'!
type
	^'time'! !

WASteppedTag subclass: #WADateTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML5-Canvas-Tags'!

!WADateTag commentStamp: 'pmm 3/16/2007 14:05' prior: 0!
supported on:
- Opera 9
graceful degeneration to text input

A date (year, month, day) encoded according to ISO 8601 [ISO8601]: four or more digits (0 to 9) representing the year, a hyphen (U+002D), two digits for the month, a hyphen, and two digits for the day. All the numbers must be in base ten and zero padded if necessary. For instance: 1995-12-31. The step attribute specifies the precision in days, defaulting to 1. User agents are expected to show an appropriate widget, such as a datepicker.!

!WADateTag methodsFor: 'accessing' stamp: 'pmm 3/16/2007 13:42'!
type
	^'date'! !

WASteppedTag subclass: #WADateTimeLocalTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML5-Canvas-Tags'!

!WADateTimeLocalTag commentStamp: 'pmm 3/16/2007 14:05' prior: 0!
supported on:
- Opera 9
graceful degeneration to text input

A date and time (year, month, day, hour, minute, second, fractions of a second) encoded according to ISO 8601 [ISO8601], with no time zone information: four or more digits (0 to 9) representing the year, a hyphen (U+002D), two digits for the month, a hyphen, two digits for the day, a literal "T", two digits for the hour, a colon (U+003A), two digits for the minute, optionally a colon and two digits for the second, and optionally (if the seconds are present) a period (U+002E) and one or more digits for the fraction of a second. All the numbers must be in base ten and zero-padded if necessary. If the seconds are omitted, they must be assumed to be zero. If the fraction is omitted, it must be assumed to be zero as well. For instance: 1995-12-31T23:59:59.99 or, representing the time 10 milliseconds later, 1996-01-01T00:00. The step attribute specifies the precision in seconds, defaulting to 60 (one minute).!

!WADateTimeLocalTag methodsFor: 'accessing' stamp: 'pmm 3/16/2007 13:52'!
type
	^'datetime-local'! !

WASteppedTag subclass: #WADateTimeTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML5-Canvas-Tags'!

!WADateTimeTag commentStamp: 'pmm 3/16/2007 14:05' prior: 0!
supported on:
- Opera 9
graceful degeneration to text input

A date and time (year, month, day, hour, minute, second, fractions of a second) encoded according to ISO 8601 [ISO8601] with the time zone set to UTC: four or more digits (0 to 9) representing the year, a hyphen (U+002D), two digits for the month, a hyphen, two digits for the day, a literal "T", two digits for the hour, a colon (U+003A), two digits for the minute, optionally a colon and two digits for the second, optionally (if the seconds are present) a period (U+002E) and one or more digits for the fraction of a second, and finally a mandatory literal "Z". All the numbers must be in base ten and zero-padded if necessary. If the seconds are omitted, they must be assumed to be zero. If the fraction is omitted, it must be assumed to be zero as well. For instance: 1995-12-31T23:59:59.99Z or, representing the time 10 milliseconds later, 1996-01-01T00:00Z. The step attribute specifies the precision in seconds, defaulting to 60 (one minute).

User agents are expected to show an appropriate widget. UAs may display the time in whatever time zone is appropriate for the user, but should be clear to the user that the time is globally defined, not time-zone dependent. The submitted date and time must be in the UTC time zone.!

!WADateTimeTag methodsFor: 'accessing' stamp: 'pmm 3/16/2007 13:49'!
type
	^'datetime'! !

WASteppedTag subclass: #WAMonthTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML5-Canvas-Tags'!

!WAMonthTag commentStamp: 'pmm 3/16/2007 14:05' prior: 0!
supported on:
- Opera 9
graceful degeneration to text input

A date consisting of a year and a month encoded according to ISO 8601 [ISO8601]: four or more digits (0 to 9) representing the year, a hyphen (U+002D), and two digits for the month, zero-padded if necessary. All the numbers must be in base ten. For instance: 1995-12. The step  attribute specifies the precision in months, defaulting to 1. This type is used most frequently for credit card expiry dates.!

!WAMonthTag methodsFor: 'accessing' stamp: 'pmm 3/16/2007 13:43'!
type
	^'month'! !

WASteppedTag subclass: #WANumberTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML5-Canvas-Tags'!

!WANumberTag commentStamp: 'pmm 3/16/2007 13:38' prior: 0!
supported on:
- Opera 9
graceful degeneration to text input

A numerical value. The step attribute specifies the precision, defaulting to 1.

Numbers must be submitted as a significand followed by an optional exponent. The significand is an optional minus sign (U+002D, "-"), an integer, and optionally a decimal point (U+002E, ".") and an integer representing the fractional part. The exponent is a lowercase literal letter "e", an optional minus sign, and an integer representing the index of a power of ten with which to multiply the significand to get the actual number. Integers are one or more decimal digits. If the exponent part is omitted its index of a power of ten must be assumed to be zero.

For example, negative-root-two, to 32 significant figures, would be -1.4142135623730950488016887242097e0, the radius of the earth given in furlongs, to an arbitrary precision, would be 3.17e4, and the answer to the life, the universe and everything could be any of (amongst others) 42, 0042.000, 42e0, 4.2e1, or 420e-1.

This format is designed to be compatible with scanf(3)'s %f format, ECMAScript's parseFloat, and similar parsers while being easier to parse than some other floating point syntaxes that are also compatible with those parsers.

The strings +0, 0e+0, and +1e+3 are all invalid numbers (the minus sign cannot be replaced by a plus sign for non-negative numbers, it must simply be omitted). Similarly, .42e2 is invalid (there must be at least one digit before the decimal point). UAs must not submit numbers in invalid formats (whatever the user might enter).

The submission format is not intended to be the format seen and used by users. UAs may use whatever format and UI is appropriate for user interaction; the description above is simply the submission format.!

!WANumberTag methodsFor: 'accessing' stamp: 'pmm 3/16/2007 12:58'!
type
	^'number'! !

!WASteppedTag methodsFor: 'attributes' stamp: 'pmm 3/16/2007 13:01'!
step: anInteger
	self attributeAt: 'step' put: anInteger! !

WASteppedTag subclass: #WAWeekTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML5-Canvas-Tags'!

!WAWeekTag commentStamp: 'pmm 3/16/2007 14:05' prior: 0!
supported on:
- Opera 9
graceful degeneration to text input

A date consisting of a year and a week number encoded according to ISO 8601 [ISO8601]: four or more digits (0 to 9) representing the year, a hyphen (U+002D), a literal "W", and two digits for the week, zero-padded if necessary. All the numbers must be in base ten. The week number must be a number greater than or equal to 01. Week 01 of a given year is the week containing the 4th of January; weeks start on Monday. For instance: 2005-W52 is the week that ends on Sunday the first of January, 2006. The step attribute specifies the precision in weeks, defaulting to 1. This type is used most frequently for dates in European industry.!

!WAWeekTag methodsFor: 'accessing' stamp: 'pmm 3/16/2007 13:44'!
type
	^'week'! !

WAAbstractTextAreaTag subclass: #WAUrlTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HTML5-Canvas-Tags'!

!WAUrlTag commentStamp: 'pmm 3/16/2007 13:37' prior: 0!
supported on:
- Opera 9
graceful degeneration to text input

An IRI, as defined by [RFC3987] (the IRI token, defined in RFC 3987 section 2.2). UAs could, for example, offer the user URIs from his bookmarks. (See below for notes on IDN.) The value is called url (as opposed to iri or uri) for consistency with CSS syntax and because it is generally felt authors are more familiar with the term "URL" than the other, more technically correct terms.!

!WAUrlTag methodsFor: 'accessing' stamp: 'pmm 3/16/2007 12:57'!
type
	^'url'! !
WACanvasTagTest initialize!
WAHtml5ElementsTest initialize!
